import Cocoa
import FlutterMacOS
import Foundation

public class AssistivePlugin: NSObject, FlutterPlugin {
  public static func register(with registrar: FlutterPluginRegistrar) {
    let channel = FlutterMethodChannel(name: "plugins.flutter.io/assistive_plugin", binaryMessenger: registrar.messenger)
    let instance = AssistivePlugin()
    registrar.addMethodCallDelegate(instance, channel: channel)
  }

  public func handle(_ call: FlutterMethodCall, result: @escaping FlutterResult) {
    switch call.method {
    case "getPlatformVersion":
      result("macOS " + ProcessInfo.processInfo.operatingSystemVersionString)
    case "checkForAssibility":
      result(checkForAssibilityPermission())
    case "takeScreenShot":
      result(takeScreenShotWindow())
    default:
      result(FlutterMethodNotImplemented)
    }
  }
}

private func takeScreenShotWindow() -> Bool {
    var *path : NSString = @"/Applications/CloudSyncMac.app/Contents/Resources/screencapture.sh";
    var *args : NSArray = [NSArray arrayWithObjects:nil, nil];
    [[NSTask launchedTaskWithLaunchPath:path arguments:args] waitUntilExit];
  return true;
}

private func checkForAssibilityPermission() -> Bool {
    let allow = AXIsProcessTrusted();
    if(allow){
    return true;
    }else{
    /* let script = NSAppleScript(source: "tell application \"System Preferences\"
                                            activate
                                            set current pane to pane \"com.apple.preferences.users\"
                                            delay 2
                                            tell application \"System Events\"
                                                click radio button \"Login Items\" of tab group 1 of window \"Users & Groups\" of application process \"System Preferences\"
                                            end tell
                                        end tell")!
    var errorDict : NSDictionary?
    script.executeAndReturnError(&errorDict) */
       NSWorkspace.shared.open(URL(fileURLWithPath: "x-apple.systempreferences:com.apple.preference.security?Privacy_Accessibility"));
//        let options : NSDictionary = [kAXTrustedCheckOptionPrompt.takeRetainedValue() as NSString: true]
//        let accessibilityEnabled = AXIsProcessTrustedWithOptions(options)
    }
    return false;
}